unit SkipLabels;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ppPrnabl, ppClass, ppCtrls, ppBands, ppCache, ppDB, Db,
  DBTables, ppDBPipe, ppComm, ppRelatv, ppProd, ppReport, ppStrtch,
  ppRegion, ppPDFDevice, ppParameter;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ppReport1: TppReport;
    ppDBPipeline1: TppDBPipeline;
    Table1: TTable;
    DataSource1: TDataSource;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    ppColumnHeaderBand1: TppColumnHeaderBand;
    ppColumnFooterBand1: TppColumnFooterBand;
    Edit1: TEdit;
    Label1: TLabel;
    ppDBCalc1: TppDBCalc;
    ppDBText1: TppDBText;
    ppShape1: TppShape;
    procedure Button1Click(Sender: TObject);
    procedure ppDetailBand1BeforePrint(Sender: TObject);
    procedure ppReport1EndColumn(Sender: TObject);
    procedure ppReport1StartSecondPass(Sender: TObject);
    procedure ppReport1BeforePrint(Sender: TObject);
  private
    FSkip: Integer;
    FTotalBandsPerColumn: Integer;

    procedure InitializeReport;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  FSkip := StrToInt(Edit1.Text) + 1;
  FTotalBandsPerColumn := 0;

  ppReport1.DetailBand.BandsPerRecord := FSkip;

  ppDBCalc1.Visible := False;
  ppDBText1.Visible := False;

  ppReport1.Print;
end;

procedure TForm1.InitializeReport;
begin
  ppReport1.DetailBand.BandsPerRecord := FSkip;
  FTotalBandsPerColumn := 0;
  ppDBCalc1.Visible := False;
  ppDBText1.Visible := False;
end;

procedure TForm1.ppReport1BeforePrint(Sender: TObject);
begin
  InitializeReport;
end;

procedure TForm1.ppReport1StartSecondPass(Sender: TObject);
begin
  InitializeReport;
end;

procedure TForm1.ppDetailBand1BeforePrint(Sender: TObject);
begin
  if ((((ppReport1.CurrentColumn - 1) * FTotalBandsPerColumn) + ppReport1.DetailBand.Count) = (FSkip - 1)) then
    begin
      ppReport1.DetailBand.BandsPerRecord := 1;

      ppDBCalc1.Visible := True;
      ppDBText1.Visible := True;
    end;
end;

procedure TForm1.ppReport1EndColumn(Sender: TObject);
begin
  if (FTotalBandsPerColumn = 0) then
    FTotalBandsPerColumn := ppReport1.DetailBand.Count;
end;


end.
